
Infrastructure - Task #6375

Story # 4463 (In Progress): Incorporate Node Replication Policy into replication processing

Task # 6372 (In Progress): rehabilitate ReplicationManager "unit" tests

Refactor out dependency on a working CN

2014-09-10 17:41 - Rob Nahf

Status: In Progress Start date: 2014-09-10

Priority: Normal Due date:  

Assignee: Rob Nahf % Done: 30%

Category: d1_replication Estimated time: 0.00 hour

Target version: CCI-2.4.0   

Milestone: None Story Points:  

Product Version: *   

Description

The ReplicationManager tests depended on the D1Client.CN_URL to be able to return a v2.NodeList, which we can't do right now.

Unit tests should not depend on external resources, so this needs to be removed.  Unfortunately, this dependency is coded in the

ReplicationManager itself, and there isn't a way to configure from the test code.   D1Client.getCN() makes a call out to the

D1Client.CN_URL to retrieve the NodeList, and throws an exception if it can't find it, or can't get the node list.

If this type of exception checking is something cn_replication wants, we need to fully incorporate new libclient features to instantiate a

mock cn instance that gets picked up by D1Client, or SetitingsContextNodeLocator.  Otherwise we should use

D1NodeFactor.getCN(baseUrl), and remove any upfront checking.

History

#1 - 2014-09-10 17:43 - Rob Nahf

For now, ReplicationManager and ReplicationService fallback to an unchecked creation of a CNode if d1Client.getCN() throws and exception, logging

warnings along the way.  Revisit during v2 refactoring

#2 - 2014-09-24 18:15 - Robert Waltz

- Target version changed from 2014.16-Block.2.4 to CCI-1.5.0

#3 - 2014-10-02 19:46 - Robert Waltz

- Target version changed from CCI-1.5.0 to CCI-1.5.1

#4 - 2015-01-06 18:34 - Rob Nahf

- Target version changed from CCI-1.5.1 to CCI-2.0.0

#5 - 2016-06-14 16:42 - Rob Nahf

- % Done changed from 90 to 30

D1Client via SettingsContextNodeLocator allows instantiation of a test CN class via the property "D1Client.cnClassName".  It may allow a workaround

to refactoring all of the D1Client.getCN() calls in d1_replication  (10 calls in 5 classes).
